Scriptname RRRConfigScript extends SKI_ConfigBase  

Quest Property RRRTrackingQuest Auto
GlobalVariable Property RRR_State Auto
GlobalVariable Property RoomCost Auto
Quest Property DialogueGeneric  Auto
Quest Property DialogueRiverwood_Revised Auto

GlobalVariable Property RRR_RoomCostBraidwoodInn Auto
GlobalVariable Property RRR_RoomCostCandlehearthHall Auto
GlobalVariable Property RRR_RoomCostDeadMansDrink Auto
GlobalVariable Property RRR_RoomCostFourShieldsTavern Auto
GlobalVariable Property RRR_RoomCostFrostfruitInn Auto
GlobalVariable Property RRR_RoomCostMoorsideInn Auto
GlobalVariable Property RRR_RoomCostNightgateInn Auto
GlobalVariable Property RRR_RoomCostOldHroldanInn Auto
GlobalVariable Property RRR_RoomCostSilverBloodInn Auto
GlobalVariable Property RRR_RoomCostSleepingGiantInn Auto
GlobalVariable Property RRR_RoomCostTheBanneredMare Auto
GlobalVariable Property RRR_RoomCostTheBeeandBarb Auto
GlobalVariable Property RRR_RoomCostTheFrozenHearth Auto
GlobalVariable Property RRR_RoomCostTheWinkingSkeever Auto
GlobalVariable Property RRR_RoomCostVilemyrInn Auto
GlobalVariable Property RRR_RoomCostWindpeakInn Auto
GlobalVariable Property RRR_RoomCostRetchingNetch Auto

event OnConfigInit()
	Pages = new string[1]
	Pages[0] = "$Configuration"
	
endEvent

int OID_Status
int OID_Version

int OID_BraidwoodInn
int OID_CandlehearthHall
int OID_DeadMansDrink
int OID_FourShieldsTavern
int OID_FrostfruitInn
int OID_MoorsideInn
int OID_NightgateInn
int OID_OldHroldanInn
int OID_SilverBloodInn
int OID_SleepingGiantInn
int OID_TheBanneredMare
int OID_TheBeeandBarb
int OID_TheFrozenHearth
int OID_TheWinkingSkeever
int OID_VilemyrInn
int OID_WindpeakInn
int OID_RetchingNetch

event OnPageReset(string a_page)

	if (a_page == "")

	endIf

	if (a_page == "$Configuration")

		SetCursorFillMode(TOP_TO_BOTTOM)

		AddHeaderOption("$RoomCostConfiguration")
		
		OID_BraidwoodInn = AddSliderOption("$BraidwoodInn", RRR_RoomCostBraidwoodInn.getValueInt())
		OID_CandlehearthHall = AddSliderOption("$CandlehearthHall", RRR_RoomCostCandlehearthHall.getValueInt())
		OID_DeadMansDrink = AddSliderOption("$DeadMansDrink", RRR_RoomCostDeadMansDrink.getValueInt())
		OID_FourShieldsTavern = AddSliderOption("$FourShieldsTavern", RRR_RoomCostFourShieldsTavern.getValueInt())
		OID_FrostfruitInn = AddSliderOption("$FrostfruitInn", RRR_RoomCostFrostfruitInn.getValueInt())
		OID_MoorsideInn = AddSliderOption("$MoorsideInn", RRR_RoomCostMoorsideInn.getValueInt())
		OID_NightgateInn = AddSliderOption("$NightgateInn", RRR_RoomCostNightgateInn.getValueInt())
		OID_OldHroldanInn = AddSliderOption("$OldHroldanInn", RRR_RoomCostOldHroldanInn.getValueInt())
		OID_SilverBloodInn = AddSliderOption("$SilverBloodInn", RRR_RoomCostSilverBloodInn.getValueInt())
		OID_SleepingGiantInn = AddSliderOption("$SleepingGiantInn", RRR_RoomCostSleepingGiantInn.getValueInt())
		
		SetCursorPosition(1)
		
		if RRR_State.getValue() == 0
			OID_Status = AddTextOption("$RRRStart", "")
		else
			OID_Status = AddTextOption("$RRRStop", "")
		endif
		OID_Version = AddTextOption("$RRRCurrentVersion", "v1.7")
		
		AddEmptyOption()
		
		OID_TheBanneredMare = AddSliderOption("$TheBanneredMare", RRR_RoomCostTheBanneredMare.getValueInt())
		OID_TheBeeandBarb = AddSliderOption("$TheBeeandBarb", RRR_RoomCostTheBeeandBarb.getValueInt())
		OID_TheFrozenHearth = AddSliderOption("$TheFrozenHearth", RRR_RoomCostTheFrozenHearth.getValueInt())
		OID_TheWinkingSkeever = AddSliderOption("$TheWinkingSkeever", RRR_RoomCostTheWinkingSkeever.getValueInt())
		OID_VilemyrInn = AddSliderOption("$VilemyrInn", RRR_RoomCostVilemyrInn.getValueInt())
		OID_WindpeakInn = AddSliderOption("$WindpeakInn", RRR_RoomCostWindpeakInn.getValueInt())
		OID_RetchingNetch = AddSliderOption("$TheRetchingNetch", RRR_RoomCostRetchingNetch.getValueInt())

	endIf
endEvent

event OnOptionSelect(int option)
	string page = CurrentPage

	if (option == OID_Status)
		if RRR_State.getValue() == 0
			SetTextOptionValue(option, "$RRRExitMenu")
			RRR_Start()
		else
			SetTextOptionValue(option, "$RRRExitMenu")
			RRR_Stop()
		endif
	endif
endEvent

event OnOptionSliderOpen(int option)
	if (option == OID_BraidwoodInn)
		SetSliderDialogStartValue(RRR_RoomCostBraidwoodInn.getValueInt())
		SetSliderDialogDefaultValue(50)
		SetSliderDialogRange(1, 250)
		SetSliderDialogInterval(1)

	elseIf (option == OID_CandlehearthHall)
		SetSliderDialogStartValue(RRR_RoomCostCandlehearthHall.getValueInt())
		SetSliderDialogDefaultValue(150)
		SetSliderDialogRange(1, 250)
		SetSliderDialogInterval(1)

	elseIf (option == OID_DeadMansDrink)
		SetSliderDialogStartValue(RRR_RoomCostDeadMansDrink.getValueInt())
		SetSliderDialogDefaultValue(100)
		SetSliderDialogRange(1, 250)
		SetSliderDialogInterval(1)
		
	elseIf (option == OID_FourShieldsTavern)
		SetSliderDialogStartValue(RRR_RoomCostFourShieldsTavern.getValueInt())
		SetSliderDialogDefaultValue(80)
		SetSliderDialogRange(1, 250)
		SetSliderDialogInterval(1)
		
	elseIf (option == OID_FrostfruitInn)
		SetSliderDialogStartValue(RRR_RoomCostFrostfruitInn.getValueInt())
		SetSliderDialogDefaultValue(60)
		SetSliderDialogRange(1, 250)
		SetSliderDialogInterval(1)
		
	elseIf (option == OID_MoorsideInn)
		SetSliderDialogStartValue(RRR_RoomCostMoorsideInn.getValueInt())
		SetSliderDialogDefaultValue(80)
		SetSliderDialogRange(1, 250)
		SetSliderDialogInterval(1)
		
	elseIf (option == OID_NightgateInn)
		SetSliderDialogStartValue(RRR_RoomCostNightgateInn.getValueInt())
		SetSliderDialogDefaultValue(50)
		SetSliderDialogRange(1, 250)
		SetSliderDialogInterval(1)
		
	elseIf (option == OID_OldHroldanInn)
		SetSliderDialogStartValue(RRR_RoomCostOldHroldanInn.getValueInt())
		SetSliderDialogDefaultValue(80)
		SetSliderDialogRange(1, 250)
		SetSliderDialogInterval(1)
		
	elseIf (option == OID_SilverBloodInn)
		SetSliderDialogStartValue(RRR_RoomCostSilverBloodInn.getValueInt())
		SetSliderDialogDefaultValue(120)
		SetSliderDialogRange(1, 250)
		SetSliderDialogInterval(1)
		
	elseIf (option == OID_SleepingGiantInn)
		SetSliderDialogStartValue(RRR_RoomCostSleepingGiantInn.getValueInt())
		SetSliderDialogDefaultValue(50)
		SetSliderDialogRange(1, 250)
		SetSliderDialogInterval(1)
		
	elseIf (option == OID_TheBanneredMare)
		SetSliderDialogStartValue(RRR_RoomCostTheBanneredMare.getValueInt())
		SetSliderDialogDefaultValue(100)
		SetSliderDialogRange(1, 250)
		SetSliderDialogInterval(1)
		
	elseIf (option == OID_TheBeeandBarb)
		SetSliderDialogStartValue(RRR_RoomCostTheBeeandBarb.getValueInt())
		SetSliderDialogDefaultValue(90)
		SetSliderDialogRange(1, 250)
		SetSliderDialogInterval(1)
		
	elseIf (option == OID_TheFrozenHearth)
		SetSliderDialogStartValue(RRR_RoomCostTheFrozenHearth.getValueInt())
		SetSliderDialogDefaultValue(80)
		SetSliderDialogRange(1, 250)
		SetSliderDialogInterval(1)
	
	elseIf (option == OID_TheWinkingSkeever)
		SetSliderDialogStartValue(RRR_RoomCostTheWinkingSkeever.getValueInt())
		SetSliderDialogDefaultValue(200)
		SetSliderDialogRange(1, 250)
		SetSliderDialogInterval(1)

	elseIf (option == OID_VilemyrInn)
		SetSliderDialogStartValue(RRR_RoomCostVilemyrInn.getValueInt())
		SetSliderDialogDefaultValue(60)
		SetSliderDialogRange(1, 250)
		SetSliderDialogInterval(1)
		
	elseIf (option == OID_WindpeakInn)
		SetSliderDialogStartValue(RRR_RoomCostWindpeakInn.getValueInt())
		SetSliderDialogDefaultValue(60)
		SetSliderDialogRange(1, 250)
		SetSliderDialogInterval(1)
		
	elseIf (option == OID_RetchingNetch)
		SetSliderDialogStartValue(RRR_RoomCostRetchingNetch.getValueInt())
		SetSliderDialogDefaultValue(100)
		SetSliderDialogRange(1, 250)
		SetSliderDialogInterval(1)
		
	endIf
endEvent

event OnOptionSliderAccept(int a_option, float a_value)

	if (a_option == OID_BraidwoodInn)
		RRR_RoomCostBraidwoodInn.setValue(a_value)
		SetSliderOptionValue(a_option, a_value)
		
	elseif (a_option == OID_CandlehearthHall)
		RRR_RoomCostCandlehearthHall.setValue(a_value)
		SetSliderOptionValue(a_option, a_value)
		
	elseif (a_option == OID_DeadMansDrink)
		RRR_RoomCostDeadMansDrink.setValue(a_value)
		SetSliderOptionValue(a_option, a_value)
		
	elseif (a_option == OID_FourShieldsTavern)
		RRR_RoomCostFourShieldsTavern.setValue(a_value)
		SetSliderOptionValue(a_option, a_value)

	elseif (a_option == OID_FrostfruitInn)
		RRR_RoomCostFrostfruitInn.setValue(a_value)
		SetSliderOptionValue(a_option, a_value)
		
	elseif (a_option == OID_MoorsideInn)
		RRR_RoomCostMoorsideInn.setValue(a_value)
		SetSliderOptionValue(a_option, a_value)
		
	elseif (a_option == OID_NightgateInn)
		RRR_RoomCostNightgateInn.setValue(a_value)
		SetSliderOptionValue(a_option, a_value)
		
	elseif (a_option == OID_OldHroldanInn)
		RRR_RoomCostOldHroldanInn.setValue(a_value)
		SetSliderOptionValue(a_option, a_value)
		
	elseif (a_option == OID_SilverBloodInn)
		RRR_RoomCostSilverBloodInn.setValue(a_value)
		SetSliderOptionValue(a_option, a_value)
		
	elseif (a_option == OID_SleepingGiantInn)
		RRR_RoomCostSleepingGiantInn.setValue(a_value)
		SetSliderOptionValue(a_option, a_value)
		
	elseif (a_option == OID_TheBanneredMare)
		RRR_RoomCostTheBanneredMare.setValue(a_value)
		SetSliderOptionValue(a_option, a_value)
		
	elseif (a_option == OID_TheBeeandBarb)
		RRR_RoomCostTheBeeandBarb.setValue(a_value)
		SetSliderOptionValue(a_option, a_value)
		
	elseif (a_option == OID_TheFrozenHearth)
		RRR_RoomCostTheFrozenHearth.setValue(a_value)
		SetSliderOptionValue(a_option, a_value)
		
	elseif (a_option == OID_TheWinkingSkeever)
		RRR_RoomCostTheWinkingSkeever.setValue(a_value)
		SetSliderOptionValue(a_option, a_value)
		
	elseif (a_option == OID_VilemyrInn)
		RRR_RoomCostVilemyrInn.setValue(a_value)
		SetSliderOptionValue(a_option, a_value)
		
	elseif (a_option == OID_WindpeakInn)
		RRR_RoomCostWindpeakInn.setValue(a_value)
		SetSliderOptionValue(a_option, a_value)
		
	elseif (a_option == OID_RetchingNetch)
		RRR_RoomCostRetchingNetch.setValue(a_value)
		SetSliderOptionValue(a_option, a_value)
		
	endIf	
endEvent


Function RRR_Start()
	RRR_State.SetValue(1)
	RRRTrackingQuest.Start()
Endfunction

Function RRR_Stop()
	RRR_State.SetValue(0)
	RoomCost.setValue(10)
	RRRTrackingQuest.Stop()
	DialogueGeneric.UpdateCurrentInstanceGlobal(RoomCost)
	DialogueRiverwood_Revised.UpdateCurrentInstanceGlobal(RoomCost)
EndFunction
