Scriptname RRRTrackingScript extends ReferenceAlias  

GlobalVariable Property RoomCost  Auto
GlobalVariable Property RRR_RoomCostDefault  Auto

KeyWord Property LocTypeInn Auto
Quest Property DialogueGeneric  Auto
Quest Property DialogueRiverwood_Revised Auto

Event OnLocationChange(Location akOldLoc, Location akNewLoc)

	if akNewLoc && akNewLoc.hasKeyWord(LocTypeInn)
		InnVisit(akNewLoc)
	endif
	
EndEvent

Event OnInit()
	CompaCheck()
	InnVisit(Game.GetPlayer().GetCurrentLocation())
EndEvent

Event OnPlayerLoadGame()
	CompaCheck()
	InnVisit(Game.GetPlayer().GetCurrentLocation())
EndEvent

Function InnVisit(Location akNewLoc)

	if akNewLoc && akNewLoc.hasKeyWord(LocTypeInn)
	
		if akNewLoc == KynesgroveBraidwoodInnLocation
			RoomCost.SetValue(RRR_RoomCostBraidwoodInn.GetValue())

		elseif akNewLoc == WindhelmCandlehearthHallLocation
			RoomCost.SetValue(RRR_RoomCostCandlehearthHall.GetValue())
		
		elseif akNewLoc == FalkreathDeadMansDrinkLocation
			RoomCost.SetValue(RRR_RoomCostDeadMansDrink.GetValue())
			
		elseif akNewLoc == DragonBridgeFourShieldsTavernLocation
			RoomCost.SetValue(RRR_RoomCostFourShieldsTavern.GetValue())
			
		elseif akNewLoc == RoriksteadFrostfruitInnLocation
			RoomCost.SetValue(RRR_RoomCostFrostfruitInn.GetValue())
			
		elseif akNewLoc == MorthalMoorsideInnLocation
			RoomCost.SetValue(RRR_RoomCostMoorsideInn.GetValue())
			
		elseif akNewLoc == NightgateInnLocation
			RoomCost.SetValue(RRR_RoomCostNightgateInn.GetValue())
			
		elseif akNewLoc == OldHroldanInnLocation
			RoomCost.SetValue(RRR_RoomCostOldHroldanInn.GetValue())
			
		elseif akNewLoc == MarkarthSilverBloodInnLocation
			RoomCost.SetValue(RRR_RoomCostSilverBloodInn.GetValue())
			
		elseif akNewLoc == WhiterunBanneredMareLocation
			RoomCost.SetValue(RRR_RoomCostTheBanneredMare.GetValue())
			
		elseif akNewLoc == RiftenBeeandBarbLocation
			RoomCost.SetValue(RRR_RoomCostTheBeeandBarb.GetValue())
			
		elseif akNewLoc == WinterholdTheFrozenHearthLocation
			RoomCost.SetValue(RRR_RoomCostTheFrozenHearth.GetValue())
			
		elseif akNewLoc == SolitudeWinkingSkeeverLocation
			RoomCost.SetValue(RRR_RoomCostTheWinkingSkeever.GetValue())
			
		elseif akNewLoc == IvarsteadVilemyrInnLocation
			RoomCost.SetValue(RRR_RoomCostVilemyrInn.GetValue())
			
		elseif akNewLoc == DawnstarWindpeakInnLocation
			RoomCost.SetValue(RRR_RoomCostWindpeakInn.GetValue())
			
		elseif akNewLoc == DLC2RRRetchingNetchLocation
			RoomCost.SetValue(RRR_RoomCostRetchingNetch.GetValue())
			
		elseif akNewLoc == RiverwoodSleepingGiantInnLocation
			RoomCost.SetValue(RRR_RoomCostSleepingGiantInn.GetValue())
			DialogueRiverwood_Revised.UpdateCurrentInstanceGlobal(RoomCost)			
		else
			RoomCost.SetValue(RRR_RoomCostDefault.GetValue())
		endif
		
		DialogueGeneric.UpdateCurrentInstanceGlobal(RoomCost)
		
	endif

EndFunction

Function CompaCheck()

	if Game.GetFormFromFile(0x00019A24, "Dragonborn.esm")
		DLC2RRRetchingNetchLocation = Game.GetFormFromFile(0x00019A24, "Dragonborn.esm") as Location
	else
		DLC2RRRetchingNetchLocation = None
		Debug.Trace("RRR: Dragonborn DLC not found...")
	endif
	
EndFunction

Location Property DLC2RRRetchingNetchLocation Auto
GlobalVariable Property RRR_RoomCostRetchingNetch Auto

Location Property KynesgroveBraidwoodInnLocation Auto
Location Property WindhelmCandlehearthHallLocation Auto
Location Property FalkreathDeadMansDrinkLocation Auto
Location Property DragonBridgeFourShieldsTavernLocation Auto
Location Property RoriksteadFrostfruitInnLocation Auto
Location Property MorthalMoorsideInnLocation Auto
Location Property NightgateInnLocation Auto
Location Property OldHroldanInnLocation Auto
Location Property MarkarthSilverBloodInnLocation Auto
Location Property RiverwoodSleepingGiantInnLocation Auto
Location Property WhiterunBanneredMareLocation Auto
Location Property RiftenBeeandBarbLocation Auto
Location Property WinterholdTheFrozenHearthLocation Auto
Location Property SolitudeWinkingSkeeverLocation Auto
Location Property IvarsteadVilemyrInnLocation Auto
Location Property DawnstarWindpeakInnLocation Auto

GlobalVariable Property RRR_RoomCostBraidwoodInn Auto
GlobalVariable Property RRR_RoomCostCandlehearthHall Auto
GlobalVariable Property RRR_RoomCostDeadMansDrink Auto
GlobalVariable Property RRR_RoomCostFourShieldsTavern Auto
GlobalVariable Property RRR_RoomCostFrostfruitInn Auto
GlobalVariable Property RRR_RoomCostMoorsideInn Auto
GlobalVariable Property RRR_RoomCostNightgateInn Auto
GlobalVariable Property RRR_RoomCostOldHroldanInn Auto
GlobalVariable Property RRR_RoomCostSilverBloodInn Auto
GlobalVariable Property RRR_RoomCostSleepingGiantInn Auto
GlobalVariable Property RRR_RoomCostTheBanneredMare Auto
GlobalVariable Property RRR_RoomCostTheBeeandBarb Auto
GlobalVariable Property RRR_RoomCostTheFrozenHearth Auto
GlobalVariable Property RRR_RoomCostTheWinkingSkeever Auto
GlobalVariable Property RRR_RoomCostVilemyrInn Auto
GlobalVariable Property RRR_RoomCostWindpeakInn Auto

