Scriptname RRR_QuestScript extends Quest  

MiscObject Property Gold001 Auto
Potion Property EmptyBottle Auto
ReferenceAlias Property Innkeeper Auto
GlobalVariable Property RRR_KegCost Auto

GlobalVariable Property RoomCost  Auto
GlobalVariable Property RRR_RoomCost3Days  Auto
GlobalVariable Property RRR_RoomCostES  Auto
GlobalVariable Property RRR_RoomCostDefault  Auto
GlobalVariable Property RRR_Discount3Days  Auto
GlobalVariable Property RRR_EnhancedMode Auto
GlobalVariable Property RRR_IKTI  Auto

KeyWord Property LocTypeInn Auto
Quest Property DialogueGeneric  Auto
Quest Property DialogueRiverwood_Revised Auto

Event OnInit()
	CompaCheck()
EndEvent

ReferenceAlias Function GetCurrentInnkeeper()
	Return Innkeeper
EndFunction

int Function CountFollowers()

	int kNPC = 43
	int count = 0
	Actor PlayerRef = Game.GetPlayer()
	Cell InnCell = PlayerRef.getParentCell()
	
	int i = InnCell.getNumRefs(kNPC)
	while (i > 0)
		i -= 1
		Actor npc = InnCell.getNthRef(i, kNPC) as Actor
		if (npc && npc != PlayerRef && npc.isPlayerTeammate())
			count += 1
		endIf
	endWhile
	
	return count
	
EndFunction

Function InnKeg(Potion drink)
	Actor PlayerRef = Game.GetPlayer()
	if EmptyBottle && PlayerRef.GetItemCount(EmptyBottle) >= 1
		PlayerRef.RemoveItem(Gold001, RRR_KegCost.GetValueInt())
		PlayerRef.RemoveItem(EmptyBottle, 1)
		PlayerRef.AddItem(drink, 1)
	endif
EndFunction

Function InnVisit(Location akNewLoc)

	if akNewLoc && akNewLoc.hasKeyWord(LocTypeInn)
	
		if akNewLoc == KynesgroveBraidwoodInnLocation
			RoomCost.SetValue(RRR_RoomCostBraidwoodInn.GetValue())
			Innkeeper = IKIddra
			RRR_IKTI.SetValue(1)
			
		elseif akNewLoc == WindhelmCandlehearthHallLocation
			RoomCost.SetValue(RRR_RoomCostCandlehearthHall.GetValue())
			Innkeeper = IKElda
			RRR_IKTI.SetValue(1)
		
		elseif akNewLoc == FalkreathDeadMansDrinkLocation
			RoomCost.SetValue(RRR_RoomCostDeadMansDrink.GetValue())
			Innkeeper = IKValgaVinicia
			RRR_IKTI.SetValue(1)
			
		elseif akNewLoc == DragonBridgeFourShieldsTavernLocation
			RoomCost.SetValue(RRR_RoomCostFourShieldsTavern.GetValue())
			Innkeeper = IKFaida
			RRR_IKTI.SetValue(1)
			
		elseif akNewLoc == RoriksteadFrostfruitInnLocation
			RoomCost.SetValue(RRR_RoomCostFrostfruitInn.GetValue())
			Innkeeper = IKMralki
			RRR_IKTI.SetValue(1)
			
		elseif akNewLoc == MorthalMoorsideInnLocation
			RoomCost.SetValue(RRR_RoomCostMoorsideInn.GetValue())
			Innkeeper = IKJonna
			RRR_IKTI.SetValue(1)
			
		elseif akNewLoc == NightgateInnLocation
			RoomCost.SetValue(RRR_RoomCostNightgateInn.GetValue())
			Innkeeper = IKHadring
			RRR_IKTI.SetValue(1)
			
		elseif akNewLoc == OldHroldanInnLocation
			RoomCost.SetValue(RRR_RoomCostOldHroldanInn.GetValue())
			Innkeeper = IKEydis
			RRR_IKTI.SetValue(1)
			
		elseif akNewLoc == MarkarthSilverBloodInnLocation
			RoomCost.SetValue(RRR_RoomCostSilverBloodInn.GetValue())
			Innkeeper = IKKleppr
			RRR_IKTI.SetValue(1)
			
		elseif akNewLoc == WhiterunBanneredMareLocation
			RoomCost.SetValue(RRR_RoomCostTheBanneredMare.GetValue())
			Innkeeper = IKHulda
			RRR_IKTI.SetValue(1)
			
		elseif akNewLoc == RiftenBeeandBarbLocation
			RoomCost.SetValue(RRR_RoomCostTheBeeandBarb.GetValue())
			Innkeeper = IKKeerava
			RRR_IKTI.SetValue(1)
			
		elseif akNewLoc == WinterholdTheFrozenHearthLocation
			RoomCost.SetValue(RRR_RoomCostTheFrozenHearth.GetValue())
			Innkeeper = IKDagur
			RRR_IKTI.SetValue(1)
			
		elseif akNewLoc == SolitudeWinkingSkeeverLocation
			RoomCost.SetValue(RRR_RoomCostTheWinkingSkeever.GetValue())
			Innkeeper = IKCorpulusVinius
			RRR_IKTI.SetValue(1)
			
		elseif akNewLoc == IvarsteadVilemyrInnLocation
			RoomCost.SetValue(RRR_RoomCostVilemyrInn.GetValue())
			Innkeeper = IKWilhelm
			RRR_IKTI.SetValue(1)
			
		elseif akNewLoc == DawnstarWindpeakInnLocation
			RoomCost.SetValue(RRR_RoomCostWindpeakInn.GetValue())
			Innkeeper = IKThoring
			RRR_IKTI.SetValue(1)
			
		elseif akNewLoc == DLC2RRRetchingNetchLocation
			RoomCost.SetValue(RRR_RoomCostRetchingNetch.GetValue())
			Innkeeper = IKGeldisSadri
			RRR_IKTI.SetValue(1)
			
		elseif akNewLoc == RiverwoodSleepingGiantInnLocation
			RoomCost.SetValue(RRR_RoomCostSleepingGiantInn.GetValue())
			DialogueRiverwood_Revised.UpdateCurrentInstanceGlobal(RoomCost)
			Innkeeper = IKOrgnar
			RRR_IKTI.SetValue(1)
		
		else
			RRR_IKTI.SetValue(0)
			RoomCost.SetValue(RRR_RoomCostDefault.GetValue())
			Innkeeper = None
		endif
		
		DialogueGeneric.UpdateCurrentInstanceGlobal(RoomCost)
		
		if Innkeeper != None
			Self.UpdateCurrentInstanceGlobal(RoomCost)
			RRR_RoomCost3Days.SetValue(RoomCost.GetValue() * 3 * (100 - RRR_Discount3Days.GetValueInt()) / 100)
			RRR_RoomCostES.SetValue(RoomCost.GetValue() * 4)
			Self.UpdateCurrentInstanceGlobal(RRR_RoomCost3Days)
			Self.UpdateCurrentInstanceGlobal(RRR_RoomCostES)
		endif

	endif

EndFunction

Function CompaCheck()

	if Game.GetFormFromFile(0x000043B0, "RealisticNeedsandDiseases.esp")
		EmptyBottle = Game.GetFormFromFile(0x000043B0, "RealisticNeedsandDiseases.esp") as Potion
	else
		EmptyBottle = None
		Debug.Trace("RRR: Realistic Needs and Diseases not found...")
	endif
	
EndFunction

Function Reset()
	(IKIddra as RRR_RentRoomScript).ClearRoom()
	(IKElda as RRR_RentRoomScript).ClearRoom()
	(IKValgaVinicia as RRR_RentRoomScript).ClearRoom()
	(IKFaida as RRR_RentRoomScript).ClearRoom()
	(IKCorpulusVinius as RRR_RentRoomScript).ClearRoom()
	(IKJonna as RRR_RentRoomScript).ClearRoom()
	(IKHadring as RRR_RentRoomScript).ClearRoom()
	(IKThoring as RRR_RentRoomScript).ClearRoom()
	(IKKleppr as RRR_RentRoomScript).ClearRoom()
	(IKEydis as RRR_RentRoomScript).ClearRoom()
	(IKKeerava as RRR_RentRoomScript).ClearRoom()
	(IKWilhelm as RRR_RentRoomScript).ClearRoom()
	(IKMralki as RRR_RentRoomScript).ClearRoom()
	(IKOrgnar as RRR_RentRoomScript).ClearRoom()
	(IKHulda as RRR_RentRoomScript).ClearRoom()
	(IKDagur as RRR_RentRoomScript).ClearRoom()
	(IKGeldisSadri as RRR_RentRoomScript).ClearRoom()
EndFunction


Location Property DLC2RRRetchingNetchLocation Auto
GlobalVariable Property RRR_RoomCostRetchingNetch Auto
ReferenceAlias Property IKGeldisSadri Auto

Location Property KynesgroveBraidwoodInnLocation Auto
Location Property WindhelmCandlehearthHallLocation Auto
Location Property FalkreathDeadMansDrinkLocation Auto
Location Property DragonBridgeFourShieldsTavernLocation Auto
Location Property RoriksteadFrostfruitInnLocation Auto
Location Property MorthalMoorsideInnLocation Auto
Location Property NightgateInnLocation Auto
Location Property OldHroldanInnLocation Auto
Location Property MarkarthSilverBloodInnLocation Auto
Location Property RiverwoodSleepingGiantInnLocation Auto
Location Property WhiterunBanneredMareLocation Auto
Location Property RiftenBeeandBarbLocation Auto
Location Property WinterholdTheFrozenHearthLocation Auto
Location Property SolitudeWinkingSkeeverLocation Auto
Location Property IvarsteadVilemyrInnLocation Auto
Location Property DawnstarWindpeakInnLocation Auto

GlobalVariable Property RRR_RoomCostBraidwoodInn Auto
GlobalVariable Property RRR_RoomCostCandlehearthHall Auto
GlobalVariable Property RRR_RoomCostDeadMansDrink Auto
GlobalVariable Property RRR_RoomCostFourShieldsTavern Auto
GlobalVariable Property RRR_RoomCostFrostfruitInn Auto
GlobalVariable Property RRR_RoomCostMoorsideInn Auto
GlobalVariable Property RRR_RoomCostNightgateInn Auto
GlobalVariable Property RRR_RoomCostOldHroldanInn Auto
GlobalVariable Property RRR_RoomCostSilverBloodInn Auto
GlobalVariable Property RRR_RoomCostSleepingGiantInn Auto
GlobalVariable Property RRR_RoomCostTheBanneredMare Auto
GlobalVariable Property RRR_RoomCostTheBeeandBarb Auto
GlobalVariable Property RRR_RoomCostTheFrozenHearth Auto
GlobalVariable Property RRR_RoomCostTheWinkingSkeever Auto
GlobalVariable Property RRR_RoomCostVilemyrInn Auto
GlobalVariable Property RRR_RoomCostWindpeakInn Auto

ReferenceAlias Property IKIddra Auto
ReferenceAlias Property IKElda Auto
ReferenceAlias Property IKValgaVinicia Auto
ReferenceAlias Property IKFaida Auto
ReferenceAlias Property IKCorpulusVinius Auto
ReferenceAlias Property IKJonna Auto
ReferenceAlias Property IKHadring Auto
ReferenceAlias Property IKThoring Auto
ReferenceAlias Property IKKleppr Auto
ReferenceAlias Property IKEydis Auto
ReferenceAlias Property IKKeerava Auto
ReferenceAlias Property IKWilhelm Auto
ReferenceAlias Property IKMralki Auto
ReferenceAlias Property IKOrgnar Auto
ReferenceAlias Property IKHulda Auto
ReferenceAlias Property IKDagur Auto

